//Import the Main and Meta object
const Main = imports.ui.main;
const Meta = imports.gi.Meta;

//Import Dash also
const Dash = Main.overview._dash;

//Import the convenience.js (Used for loading settings schemas)
const Self = imports.misc.extensionUtils.getCurrentExtension();
const Convenience = Self.imports.convenience;


//Load the keybinging settings on loading
function init() {
    settings = Convenience.getSettings();
}

//This is a javascript-closure which will return the event handler
//for each hotkey with it's id. (id=1 For <Super>+1 etc)

function clickClosure(id)
{
    return function(){
        //global.log('Switchin to app '+id+' in dash.');

        Dash._redisplay; //Re-order apps in dash before loading

        //FIXME After starting up the gnome-shell, it takes some time to dash
        // elements become accessable. Until that, <Super>-1 keywords are unuseable!
  

        // Get the current actors from Dash, and get apps from the actors
        // This part is copied from the dash source (/usr/share/gnomes-shell/js/ui/dash.js)
        let children = Dash._box.get_children().filter(function(actor) {
                return actor._delegate.child &&
                       actor._delegate.child._delegate &&
                       actor._delegate.child._delegate.app;
            });
        let apps = children.map(function(actor) {
                return actor._delegate.child._delegate.app;
            });

        if(typeof(apps[id]) !== 'undefined') { //This is just to ignore problems when there is no such app (yet).
	    apps[id].activate();
            }
        }
}

function enable() {
    Dash._redisplay; //This hack tryes to fix the Dash elements unaccesabble problem after startup
    global.display.add_keybinding('dashapp-hotkey-1', settings, Meta.KeyBindingFlags.NONE, clickClosure(0));
    global.display.add_keybinding('dashapp-hotkey-2', settings, Meta.KeyBindingFlags.NONE, clickClosure(1));
    global.display.add_keybinding('dashapp-hotkey-3', settings, Meta.KeyBindingFlags.NONE, clickClosure(2));
    global.display.add_keybinding('dashapp-hotkey-4', settings, Meta.KeyBindingFlags.NONE, clickClosure(3));
    global.display.add_keybinding('dashapp-hotkey-5', settings, Meta.KeyBindingFlags.NONE, clickClosure(4));
    global.display.add_keybinding('dashapp-hotkey-6', settings, Meta.KeyBindingFlags.NONE, clickClosure(5));
    global.display.add_keybinding('dashapp-hotkey-7', settings, Meta.KeyBindingFlags.NONE, clickClosure(6));
    global.display.add_keybinding('dashapp-hotkey-8', settings, Meta.KeyBindingFlags.NONE, clickClosure(7));
    global.display.add_keybinding('dashapp-hotkey-9', settings, Meta.KeyBindingFlags.NONE, clickClosure(8));
}

function disable() {
    global.display.remove_keybinding('dashapp-hotkey-1');
    global.display.remove_keybinding('dashapp-hotkey-2');
    global.display.remove_keybinding('dashapp-hotkey-3');
    global.display.remove_keybinding('dashapp-hotkey-4');
    global.display.remove_keybinding('dashapp-hotkey-5');
    global.display.remove_keybinding('dashapp-hotkey-6');
    global.display.remove_keybinding('dashapp-hotkey-7');
    global.display.remove_keybinding('dashapp-hotkey-8');
    global.display.remove_keybinding('dashapp-hotkey-9');
}
